clear

cd 'G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
path='G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';

year='2013'; %Other years are = { 1993, 1999, 2006, 2013 }
load([path '\data\Data' year '.mat']); 

path='G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
addpath([path '\functions\']);

rng(12345) %Set seed

%
% Select Regions from Austria or Germany
%
%SelectRegions

%
% Define T0, w0 and t0
%
T0=transfers_tot./L0;

Tw0=(transfers_tot-transfers_prod-transfers_trans)./L0;
Ta0=transfers_prod./L0;
Td0=transfers_trans./L0;

PARA.ShareTw0=sum(Tw0.*L0)./sum(T0.*L0);
PARA.ShareTa0=sum(Ta0.*L0)./sum(T0.*L0);
PARA.ShareTd0=sum(Td0.*L0)./sum(T0.*L0);

sh_Tw0=Tw0./T0;
sh_Ta0=Ta0./T0;
sh_Td0=Td0./T0;

sh_Tw0(sh_Tw0==0)=1e-40;
sh_Ta0(sh_Ta0==0)=1e-40;
sh_Td0(sh_Td0==0)=1e-40;

PARA.TBAR=sum(T0.*L0);
PARA.TS0=T0.*L0/sum(T0.*L0);

PARA.TBARw=sum(Tw0.*L0);
PARA.TSw0=Tw0.*L0/sum(Tw0.*L0);

PARA.TBARa=sum(Ta0.*L0);
PARA.TSa0=Ta0.*L0/sum(Ta0.*L0);

PARA.TBARd=sum(Td0.*L0);
PARA.TSd0=Td0.*L0/sum(Td0.*L0);

PARA.TBARc=PARA.TBAR;

housingExp=(1-PARA.alpha)*v0.*L0;

%
% Solve for iota, w0 and t0 simultaneously
%
disp(['Solve for iota, w0 and t0 simultaneously']);
solveIotaWt

%
% Recover fundamentals: Production amenities, trade share, location
% attractiveness and migration costs
%
solveRecoverFundamentals

PARA.tax_contribution=tax_contribution;
PARA.t0=t0;
PARA.T0=T0;

PARA_in;

%
% Calculate production amenities and travel time if zero transfers are paid
%
T_dec=PARA.PolygonNeig.*PARA.kappa_d.*log(1+(repmat((1./PARA.NumOfLinks).*(PARA.TSd0.*PARA.TBARd),[1,n])+repmat(((1./PARA.NumOfLinks).*(PARA.TSd0.*PARA.TBARd))',[n,1])));
PARA.droad_zero=PARA.droad0+T_dec;

PARA.a0_BAR=PARA.a0./(((PARA.TSa0.*PARA.TBARa)./(PARA.lambda0.*PARA.LBAR)+1).^PARA.kappa_a.*(PARA.L0.^PARA.mu));

disp('****************************')
disp('Overview of main recovered variables ')
disp('****************************')
T = table(regions,id_0,a0,PARA.a0_BAR,diag(pi0),diag(d0),B0,w0,v0,L0,H0,iota,t0,P0,r0,CMA0,FMA0,sumd0,sum(ddist0,2),sum(droad0,2),PARA.NumOfLinks,MA,Utility0,T0,Tw0,Ta0,Td0,sh_Tw0,sh_Ta0,sh_Td0,object_1,repmat(PARA.chi,[n,1]))
T.Properties.VariableNames = {'Region' 'RegionID' 'a0' 'a0bar' 'diagPI0' 'diagd0' 'B0' 'w0' 'v0' 'L0' 'H0' 'iota' 'tau0' 'P0' 'r0' 'CMA0' 'FMA0' 'sumd0' 'sumdist0' 'sumdroad0' 'NumOfLinks' 'MA' 'U0' 'T0' 'Tw0' 'Ta0' 'Td0' 'sh_Tw0' 'sh_Ta0' 'sh_Td0' 'object1' 'chi'};
filename = [path '\output\xls\output.xlsx'];
system('taskkill /F /IM EXCEL.EXE');
writetable(T,filename,'Sheet',['Full Model ' year ' Ka 1']);

id_d0=zeros(n*n,1);
for i=1:1:n*n
    id_d0(i)=i;
end

td0=PARA.d0;
td0(logical(eye(size(td0)))) = NaN;

tinf0 = exp(PARA.kappa_AA.*PARA.PolygonNeig.*PARA.droad0);
tinf0(PARA.PolygonNeig==0)=NaN;

tt0 = PARA.PolygonNeig.*PARA.droad0;
tt0(PARA.PolygonNeig==0)=NaN;

T = table(id_d0,reshape(PARA.d0,[n*n,1]),reshape(td0,[n*n,1]),reshape(tinf0,[n*n,1]),reshape(tt0,[n*n,1]),reshape(repmat(PARA.regions,[n,1]),[n*n,1]),reshape(repmat(PARA.regions',[n,1]),[n*n,1]),reshape(PARA.PolygonNeig,[n*n,1]));
T.Properties.VariableNames = {'id' 'TradeCosts' 'bilTradeCosts' 'tinf0' 'traveltime' 'OrigReg' 'DestReg' 'Adj'};
filename = [path '\output\xls\output.xlsx'];
system('taskkill /F /IM EXCEL.EXE');
writetable(T,filename,'Sheet',['Trade Costs ' year ' Ka 1']);

%
% Maximum reduction in TT
%
max(max(PARA.PolygonNeig.*PARA.kappa_d.*log(1+(repmat((1./PARA.NumOfLinks).*(PARA.TBARd),[1,n])+repmat(((1./PARA.NumOfLinks).*(PARA.TBARd))',[n,1])))))

%
% Minimum level of gamma ni
%
A=PARA.droad_zero.*PARA.PolygonNeig;
B=reshape(A,[n*n,1]);
B(B==0)=[];
min(B)


%
% PARAdroad0
%
%unique(PARA.PolygonNeig.*PARA.droad_zero)

save([path '\output\mat\Results_', year , '_KAPPA1.mat'], 'PARA')

%
% Correlation Matrix
%
corr([PARA.a0,PARA.B0,diag(PARA.pi0)])

%
% Create figure comparing modelled tradebalance with data
%
tradebalance_model=iota.*housingExp-L0.*chi;
zw=tradebalance-tradebalance_model;

T = table(regions,iota,tradebalance,tradebalance_model)
sum(zw.^2);
disp('Correlation between modelled and observed trade balance:')
corr(tradebalance,tradebalance_model)

id=ones(n,1);
for i=1:n
     id(i,1)=i;
end
A=[tradebalance./1000000000,tradebalance_model./1000000000,zw./1000000000,iota,id];

A=sortrows(A,1);

if year=='2013' & n>250

figure
    i=1;
    f=100;
    subplot(3,1,1);
    b=bar(A(i:f,1:2));
    axis([0 101 -25 0])
    %xlabel('Regions')
    ylabel('in Billion EUR')
    set(gca, 'XTick', 1:f-i+1, 'XTickLabel', regions(A(i:f,5),1))
    set(gca,'XTickLabelRotation',45)
    set(b(2),'FaceColor','r');
    set(b,'EdgeColor','black');
    
    yyaxis right
    ylabel('Right Side')
    plot(A(i:f,4),'d');
    ylim([-3 3])
    
    i=101;
    f=200;
    subplot(3,1,2);
    b=bar(A(i:f,1:2));
    axis([0 101 -5 5])
    %xlabel('Regions')
    ylabel('in Billion EUR')
    set(gca, 'XTick', 1:f-i+1, 'XTickLabel', regions(A(i:f,5),1))
    set(gca,'XTickLabelRotation',45)    
    set(b(2),'FaceColor','r');
    set(b,'EdgeColor','black');
    
    yyaxis right
    ylabel('Right Side')
    plot(A(i:f,4),'d');
    ylim([-3 3])
    
    i=201;
    f=n;
    subplot(3,1,3);
    b=bar(A(i:f,1:2));
    axis([0 101 0 35])
    %xlabel('Regions')
    ylabel('in Billion EUR')
    set(gca, 'XTick', 1:f-i+1, 'XTickLabel', regions(A(i:f,5),1))
    set(gca,'XTickLabelRotation',45)      
    set(b(2),'FaceColor','r');
    set(b,'EdgeColor','black');
    
    yyaxis right
    ylabel('Right Side')
    plot(A(i:f,4),'d');
    ylim([-3 3])
    
    legend('Observed Trade Balance (Left Axis)','Model (Left Axis)','iota (Right Axis)')
end




